\ BRESENHAM'S LINE ALGORITHM
\ FROM ROSETTACODE.ORG
EXEC: STEEP      \ NOOP or SWAP
EXEC: YSTEP      \ 1+ or 1-

VALUE Y       VALUE COLOR
VALUE DELTAX  VALUE DELTAY

: LINE  ( x0 y0 x1 y1 color -- )
  TO COLOR
  ROT SWAP        ( x0 x1 y0 y1)
  2DUP - ABS >R 2OVER - ABS R> <
  IF    ' SWAP     \ swap use of
                   \ x and y
  ELSE 2SWAP ' NOOP
  THEN  IS STEEP  ( y0 y1 x0 x1)
  2DUP >
  IF SWAP 2SWAP SWAP   \ ensure
                       \ x1 > x0
  ELSE  2SWAP
  THEN            ( x0 x1 y0 y1)
  2DUP >
  IF   ' 1-  ELSE  ' 1+
  THEN IS YSTEP
  OVER - ABS    TO DELTAY TO Y
  SWAP 2DUP - DUP TO DELTAX
  2/ ROT 1+ ROT ( error x1+1 x0)
  DO  I Y STEEP COLOR PLOT
      DELTAY - DUP 0<
      IF Y YSTEP TO Y DELTAX +
      THEN
  LOOP  DROP ;
